"use strict";

require("core-js/modules/es.array.slice");

require("core-js/modules/es.object.define-properties");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.string.trim");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Lexer = Lexer;

var _tools = require("./tools/tools");

function Lexer() {}

Object.defineProperties(Lexer.prototype, {
  analysis: {
    value: analysis
  }
});
/**
 * 分解传入的HTML字符串
 * @param str - HTML字符串
 * @return {[]}
 */

function analysis(str) {
  str = _tools.Tools.trim(str);
  console.time('lexical analysis');
  var result = [];

  var stack = [],
      _char,
      start = 0,
      end = 0;

  for (var i = 0, len = str.length, depth; i < len; i++) {
    depth = stack.length;
    _char = str[i];

    switch (_char) {
      case '<':
        stack.push(_char);

        if (depth === 0) {
          start = i; // 截取HTML标签之间的文本

          if (start - end > 1 && !_tools.Tools.isEmpty(str, end + 1, start - 1)) result.push(str.slice(end + 1, start));
        }

        break;

      case '>':
        stack.pop();

        if (depth === 1) {
          end = i;
          result.push(str.slice(start, end + 1));
        }

    }
  }

  console.timeEnd('lexical analysis');
  return result;
}